/*
 *  PrecompiledHeader.h
 *  OpenLieroX
 *
 *	Use this header as your precompiled header if your compiler supports that.
 *
 *  Created by Albert Zeyer on 09.02.09.
 *  code under LGPL
 *
 */

#ifdef __PRECOMPILEDHEADER_H__
#error PrecompiledHeader.hpp cannot be used in the regular code.
#define __PRECOMPILEDHEADER_H__
#endif

#if !defined(__cplusplus)
// We're compiling C-code here, HawkNL most probably
#else

#include "Autocompletion.h"
#include "AuxLib.h"
#include "Cache.h"
#include "CBanList.h"
#include "CBonus.h"
#include "CBytestream.h"
#include "CChannel.h"
#include "CChatBox.h"
#include "CClient.h"
#include "CClientNetEngine.h"
#include "CFont.h"
#include "CGameMode.h"
#include "CGameObject.h"
#include "CGameScript.h"
#include "CGameSkin.h"
#include "ChatCommand.h"
#include "CHideAndSeek.h"
#include "CInput.h"
#include "Clipboard.h"
#include "CMap.h"
#include "CNinjaRope.h"
#include "Color.h"
#include "Condition.h"
#include "ConfigHandler.h"
#include "Consts.h"
#include "ConversationLogger.h"
#include "CProjectile.h"
#include "CrashHandler.h"
#include "CScriptableVars.h"
#include "CServerConnection.h"
#include "CServer.h"
#include "CServerNetEngine.h"
#include "CShootList.h"
#include "CssParser.h"
#include "CsvReader.h"
#include "Cursor.h"
#include "CVec.h"
#include "CViewport.h"
#include "CWeather.h"
#include "CWormBot.h"
#include "CWorm.h"
#include "CWormHuman.h"
#include "CWpnRest.h"
#include "Debug.h"
#include "DedicatedControl.h"
#include "DynDraw.h"
#include "EndianSwap.h"
#include "Entity.h"
#include "Error.h"
#include "Event.h"
#include "EventQueue.h"
#include "FastVector.h"
#include "FeatureList.h"
#include "FileDownload.h"
#include "FileUtils.h"
#include "FindFile.h"
#include "FlagInfo.h"
#include "FontEffects.h"
#include "FontHandling.h"
#include "Frame.h"
#include "Functors.h"
#include "GeoIPDatabase.h"
#include "Geometry.h"
#include "GfxPrimitives.h"
#include "GuiPrimitives.h"
#include "HTTP.h"
#include "IniReader.h"
#include "InputEvents.h"
#include "InternDataClass.h"
#include "IpToCountryDB.h"
#include "IRC.h"
#include "IRC_ReplyCodes.h"
#include "Iterator.h"
#include "LieroX.h"
#include "MapLoader.h"
#include "MathLib.h"
#include "Music.h"
#include "Mutex.h"
#include "Networking.h"
#include "NewNetEngine.h"
#include "NotifyUser.h"
#include "OLXCommand.h"
#include "OLXConsole.h"
#include "OLXG15.h"
#include "Options.h"
#include "PhysicsDummy.h"
#include "Physics.h"
#include "PhysicsLX56.h"
#include "PixelFunctors.h"
#include "PreInitVar.h"
#include "Process.h"
#include "ProfileSystem.h"
#include "ProjAction.h"
#include "ProjectileDesc.h"
#include "Protocol.h"
#include "RandomNumberList.h"
#include "ReadWriteLock.h"
#include "RefCounter.h"
#include "Ref.h"
#include "SafeVector.h"
#include "sex.h"
#include "SmartPointer.h"
#include "SMTP.h"
#include "StackWalker.h"
#include "StringBuf.h"
#include "StringUtils.h"
#include "StyleVar.h"
#include "TaskManager.h"
#include "TeeStdoutHandler.h"
#include "ThreadPool.h"
#include "ThreadVar.h"
#include "Timer.h"
#include "TSVar.h"
#include "types.h"
#include "Unicode.h"
#include "UploadSpeedTest.h"
#include "Utils.h"
#include "Version.h"
#include "WeaponDesc.h"
#include "XMLutils.h"
#include "DeprecatedGUI/CAnimation.h"
#include "DeprecatedGUI/CBar.h"
#include "DeprecatedGUI/CBox.h"
#include "DeprecatedGUI/CBrowser.h"
#include "DeprecatedGUI/CButton.h"
#include "DeprecatedGUI/CChatWidget.h"
#include "DeprecatedGUI/CCheckbox.h"
#include "DeprecatedGUI/CCombobox.h"
#include "DeprecatedGUI/CGuiLayout.h"
#include "DeprecatedGUI/CGuiSkin.h"
#include "DeprecatedGUI/CGuiSkinnedLayout.h"
#include "DeprecatedGUI/CImage.h"
#include "DeprecatedGUI/CInputBox.h"
#include "DeprecatedGUI/CLabel.h"
#include "DeprecatedGUI/CLine.h"
#include "DeprecatedGUI/CListview.h"
#include "DeprecatedGUI/CMenu.h"
#include "DeprecatedGUI/CProgressbar.h"
#include "DeprecatedGUI/CScrollbar.h"
#include "DeprecatedGUI/CSlider.h"
#include "DeprecatedGUI/CTextbox.h"
#include "DeprecatedGUI/CTextButton.h"
#include "DeprecatedGUI/CTitleButton.h"
#include "DeprecatedGUI/CWidget.h"
#include "DeprecatedGUI/CWidgetList.h"
#include "DeprecatedGUI/Graphics.h"
#include "DeprecatedGUI/Menu.h"
#include "game/Game.h"
#include "game/Level.h"
#include "game/Mod.h"
#include "game/SinglePlayer.h"
#include "game/Sounds.h"
#include "game/WormInputHandler.h"
#include "gusanos/2xsai.h"
#include "gusanos/allegro.h"
#include "gusanos/animators.h"
#include "gusanos/base_action.h"
#include "gusanos/base_animator.h"
#include "gusanos/client.h"
#include "gusanos/culling.h"
#include "gusanos/detect_event.h"
#include "gusanos/distortion.h"
#include "gusanos/encoding.h"
#include "gusanos/events.h"
#include "gusanos/explosion.h"
#include "gusanos/exp_type.h"
#include "gusanos/font.h"
#include "gusanos/game_actions.h"
#include "gusanos/gconsole.h"
#include "gusanos/gfx.h"
#include "gusanos/glua.h"
#include "gusanos/gusanos.h"
#include "gusanos/gusgame.h"
#include "gusanos/hash_table.h"
#include "gusanos/keyboard.h"
#include "gusanos/keys.h"
#include "gusanos/level_effect.h"
#include "gusanos/level.h"
#include "gusanos/material.h"
#include "gusanos/menu.h"
#include "gusanos/message_queue.h"
#include "gusanos/netstream.h"
#include "gusanos/network.h"
#include "gusanos/net_worm.h"
#include "gusanos/ninjarope.h"
#include "gusanos/noise_line.h"
#include "gusanos/object_grid.h"
#include "gusanos/objects_list.h"
#include "gusanos/parser.h"
#include "gusanos/particle.h"
#include "gusanos/part_type.h"
#include "gusanos/player_ai.h"
#include "gusanos/player_input.h"
#include "gusanos/player_options.h"
#include "gusanos/posspd_replicator.h"
#include "gusanos/proxy_player.h"
#include "gusanos/resource_base.h"
#include "gusanos/resource_list.h"
#include "gusanos/resource_locator.h"
#include "gusanos/script.h"
#include "gusanos/server.h"
#include "gusanos/simple_particle.h"
#include "gusanos/sound.h"
#include "gusanos/sprite.h"
#include "gusanos/sprite_set.h"
#include "gusanos/stl_str_replicator.h"
#include "gusanos/timer_event.h"
#include "gusanos/vector_replicator.h"
#include "gusanos/weapon.h"
#include "gusanos/weapon_type.h"
#include "gusanos/worm.h"
#include "level/LXMapFlags.h"
#include "sound/sfxdriver.h"
#include "sound/sfxdriver_openal.h"
#include "sound/sfx.h"
#include "sound/sound_sample.h"
#include "sound/sound_sample_openal.h"
#include "sound/SoundsBase.h"
#include "util/angle.h"
#include "util/bitarray.h"
#include "util/common.h"
#include "util/compare.h"
#include "util/FixedPointNumber.h"
#include "util/GusCache.h"
#include "util/log.h"
#include "util/macros.h"
#include "util/math_func.h"
#include "util/rect.h"
#include "util/stringbuild.h"
#include "util/text.h"
#include "util/trace.h"
#include "util/vec.h"
#include "game/Game.h"
#include "game/Level.h"
#include "game/Mod.h"
#include "game/SinglePlayer.h"
#include "game/Sounds.h"
#include "game/WormInputHandler.h"
#include "gusanos/2xsai.h"
#include "gusanos/allegro.h"
#include "gusanos/animators.h"
#include "gusanos/base_action.h"
#include "gusanos/base_animator.h"
#include "gusanos/client.h"
#include "gusanos/culling.h"
#include "gusanos/detect_event.h"
#include "gusanos/distortion.h"
#include "gusanos/encoding.h"
#include "gusanos/events.h"
#include "gusanos/explosion.h"
#include "gusanos/exp_type.h"
#include "gusanos/font.h"
#include "gusanos/game_actions.h"
#include "gusanos/gconsole.h"
#include "gusanos/gfx.h"
#include "gusanos/glua.h"
#include "gusanos/gusanos.h"
#include "gusanos/gusgame.h"
#include "gusanos/hash_table.h"
#include "gusanos/keyboard.h"
#include "gusanos/keys.h"
#include "gusanos/level_effect.h"
#include "gusanos/level.h"
#include "gusanos/material.h"
#include "gusanos/menu.h"
#include "gusanos/message_queue.h"
#include "gusanos/netstream.h"
#include "gusanos/network.h"
#include "gusanos/net_worm.h"
#include "gusanos/ninjarope.h"
#include "gusanos/noise_line.h"
#include "gusanos/object_grid.h"
#include "gusanos/objects_list.h"
#include "gusanos/parser.h"
#include "gusanos/particle.h"
#include "gusanos/part_type.h"
#include "gusanos/player_ai.h"
#include "gusanos/player_input.h"
#include "gusanos/player_options.h"
#include "gusanos/posspd_replicator.h"
#include "gusanos/proxy_player.h"
#include "gusanos/resource_base.h"
#include "gusanos/resource_list.h"
#include "gusanos/resource_locator.h"
#include "gusanos/script.h"
#include "gusanos/server.h"
#include "gusanos/simple_particle.h"
#include "gusanos/sound.h"
#include "gusanos/sprite.h"
#include "gusanos/sprite_set.h"
#include "gusanos/stl_str_replicator.h"
#include "gusanos/timer_event.h"
#include "gusanos/vector_replicator.h"
#include "gusanos/weapon.h"
#include "gusanos/weapon_type.h"
#include "gusanos/worm.h"
#include "level/LXMapFlags.h"
#include "sound/sfxdriver.h"
#include "sound/sfxdriver_openal.h"
#include "sound/sfx.h"
#include "sound/sound_sample.h"
#include "sound/sound_sample_openal.h"
#include "sound/SoundsBase.h"
#include "util/angle.h"
#include "util/bitarray.h"
#include "util/common.h"
#include "util/compare.h"
#include "util/FixedPointNumber.h"
#include "util/GusCache.h"
#include "util/log.h"
#include "util/macros.h"
#include "util/math_func.h"
#include "util/rect.h"
#include "util/stringbuild.h"
#include "util/text.h"
#include "util/trace.h"
#include "util/vec.h"
#include "gusanos/blitters/blitters.h"
#include "gusanos/blitters/colors.h"
#include "gusanos/blitters/context.h"
#include "gusanos/blitters/macros.h"
#include "gusanos/blitters/mmx.h"
#include "gusanos/blitters/types.h"
#include "gusanos/console/alias.h"
#include "gusanos/console/bindings.h"
#include "gusanos/console/command.h"
#include "gusanos/console/console-grammar.h"
#include "gusanos/console/console.h"
#include "gusanos/console/consoleitem.h"
#include "gusanos/console/special_command.h"
#include "gusanos/console/variables.h"
#include "gusanos/gui/omfggui.h"
#include "gusanos/gui/omfggui_windows.h"
#include "gusanos/loaders/liero.h"
#include "gusanos/loaders/LieroXLevelLoader.h"
#include "gusanos/loaders/losp.h"
#include "gusanos/loaders/vermes.h"
#include "gusanos/luaapi/classes.h"
#include "gusanos/luaapi/context.h"
#include "gusanos/luaapi/macros.h"
#include "gusanos/luaapi/types.h"
#include "gusanos/lua/bindings-game.h"
#include "gusanos/lua/bindings-gfx.h"
#include "gusanos/lua/bindings.h"
#include "gusanos/lua/bindings-math.h"
#include "gusanos/lua/bindings-network.h"
#include "gusanos/lua/bindings-objects.h"
#include "gusanos/lua/bindings-resources.h"
#include "gusanos/omfgscript/omfg_script.h"
#include "gusanos/gui/detail/button.h"
#include "gusanos/gui/detail/check.h"
#include "gusanos/gui/detail/context.h"
#include "gusanos/gui/detail/edit.h"
#include "gusanos/gui/detail/group.h"
#include "gusanos/gui/detail/label.h"
#include "gusanos/gui/detail/list.h"
#include "gusanos/gui/detail/llist.h"
#include "gusanos/gui/detail/renderer.h"
#include "gusanos/gui/detail/wnd.h"
#include "gusanos/gui/detail/xml-grammar.h"
#include "gusanos/gui/detail/xml.h"
#include "gusanos/gui/lua/bindings-gui.h"
#endif // !defined(__cplusplus)
